"""
Django settings for IPS project.

Generated by 'django-admin startproject' using Django 4.2.1.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-5a88wu*q1w9(@^yb=v%&q@537u&*yw4fl4_&7$466us1p&+!eh'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'debug_toolbar',
    'workday',
    'hubplanner',
    'salesforce',
    'estimating',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'debug_toolbar.middleware.DebugToolbarMiddleware'
]

ROOT_URLCONF = 'IPS.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'IPS.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases

DATABASES = {
    # localhost
    'default':{},
    'ProjectDB':{
        'ENGINE':'mssql',
        'NAME':'ProjectDB',
        'USER':'',                     
        'PASSWORD':'',                 
        'HOST':'localhost', 
        'PORT':'1433',                       
        'OPTIONS': {
            'driver': 'ODBC Driver 17 for SQL Server',
        },
    },
    # 'EstimatingDB':{
    #     'ENGINE':'mssql',
    #     'NAME':'EstimatingDB',
    #     'USER':'',                     
    #     'PASSWORD':'',                 
    #     'HOST':'localhost', 
    #     'PORT':'1433',                       
    #     'OPTIONS': {
    #         'driver': 'ODBC Driver 17 for SQL Server',
    #     },
    # }
    
    # # Production
    # 'default':{
    #     'ENGINE':'mssql',
    #     'NAME':'ProjectDB',
    #     'USER':'ProjectAdmin',                     
    #     'PASSWORD':'ProjectsTeam2022',                 
    #     'HOST':'llaprsql310.mhsh.local', 
    #     'PORT':'1433',                       
    #     'OPTIONS': {
    #         'driver': 'ODBC Driver 17 for SQL Server',
    #     },
    # }

    # # Production Fortna
    # 'default':{
    #     'ENGINE':'mssql',
    #     'NAME':'ProjectDB',
    #     'USER':'PowerBIUser',                     
    #     'PASSWORD':'5gZIqsUHw2',                 
    #     'HOST':'DLPROJDB-TEST1.fortna.net', 
    #     'PORT':'1433',                       
    #     'OPTIONS': {
    #         'driver': 'ODBC Driver 17 for SQL Server',
    #     },
    # }
}


# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = False


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATIC_URL = 'static/'

# Default primary key field type
# https://docs.djangoproject.com/en/4.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

REST_FRAMEWORK = {
    'DEFAULT_PAGINATION_CLASS': 'salesforce.api.paginations.CustomPagination',
    'PAGE_SIZE': 100 # we can make it dynamic from class. But, set a number as default
}

DATABASE_ROUTERS = ['routers.db_routers.AuthRouter','routers.db_routers.Estimating']

INTERNAL_IPS=[
    '127.0.0.1',
    '70.143.60.98',
]
DEBUG_TOOLBAR_CONFIG = {
    # 'NAMESPACES': ['djdt'],
    'SHOW_TOOLBAR_CALLBACK': lambda x: True
}
DEBUG_TOOLBAR_PATCH_SETTINGS = False